# Contributing to ElasticSuite

Contributions to the ElasticSuite codebase are done using the fork & pull model.
This contribution model has contributors maintaining their own copy of the forked codebase (which can easily be synced with the main copy). The forked repository is then used to submit a request to the base repository to “pull” a set of changes. For more information on pull requests please refer to [GitHub Help](https://help.github.com/articles/about-pull-requests/).

Contributions can take the form of new components or features, changes to existing features, tests, bug fixes or optimizations.

The ElasticSuite development team will review all issues and contributions submitted by the community of developers in the first in, first out order. During the review we might require clarifications from the contributor.


## Contribution requirements

1. Contributions must adhere to the [coding standards](https://github.com/Smile-SA/magento2-smilelab-quality-suite).
2. Pull requests (PRs) must be accompanied by a meaningful description of their purpose. Comprehensive descriptions increase the chances of a pull request being merged quickly and without additional clarification requests.
3. Commits must be accompanied by meaningful commit messages.
4. PRs which include bug fixes must be accompanied with a step-by-step description of how to reproduce the bug.
5. PRs which include new logic or new features must be submitted along with:
6. For larger features or changes, please [open an issue](https://github.com/Smile-SA/elasticsuite/issues) to discuss the proposed changes prior to development. This may prevent duplicate or unnecessary effort and allow other contributors to provide input.
7. All automated tests must pass (all builds on [Travis CI](https://travis-ci.org/smile-sa/elasticsuite) must be green).

## Contribution process

If you are a new GitHub user, we recommend that you create your own [free github account](https://github.com/signup/free). This will allow you to collaborate with the ElasticSuite development team, fork the ElasticSuite project and send pull requests.

1. Search current [listed issues](https://github.com/smile-sa/elasticsuite/issues) (open or closed) for similar proposals of intended contribution before starting work on a new contribution.
2. Create and test your work.
3. Fork the ElasticSuite repository and when you are done with your work, submit us a Pull Request.
4. Once your contribution is received the ElasticSuite development team will review the contribution and collaborate with you as needed.

## Code of Conduct

Please note that this project is released with a Contributor Code of Conduct. We expect you to agree to its terms when participating in this project.
